.\" {PTM/WK/2000-VI}
.TH MAWK 1  "22 grudnia 1994" "wersja 1.2" "POLECENIA UYTKOWNIKA"
.\" strings
.ds ex \fIwyra\fR
.SH NAZWA
mawk \- jzyk wyszukiwania wzorcw i przetwarzania tekstu
.SH SKADNIA
.TP 6
.B mawk
.RB [ -W
.IR opcja ]
.RB [ -F
.IR warto ]
.RB [ -v
.IR zmn\fB=\fPwarto ]
.br
.RB [ \-\- "] 'tekst programu'"
.RI [ plik ...]
.TP
.B mawk
.RB [ -W
.IR opcja ]
.RB [ -F
.IR warto ]
.RB [ -v
.IR zmn\fB=\fPwarto ]
.br
.RB [ -f
.IR plik-programu ]
.RB [ \-\- ]
.RI [ plik ...]
.SH OPIS
.B mawk
jest interpreterem jzyka programowania AWK. Jzyk AWK jest uyteczny
w dziaaniach na plikach danych, wyszukiwaniu i przetwarzaniu tekstu oraz
tworzeniu prototypw i eksperymentowaniu z algorytmami.
.B mawk
implementuje jzyk AWK, jak go zdefiniowali Aho, Kernighan i Weinberger
w ksice
.IR "The AWK Programming Language" ,
Addison-Wesley Publishing, 1988 (dalej wzmiankowanej jako ksika AWK).
.B mawk
jest zgodny z definicj jzyka AWK ze standardu Posix 1003.2
(propozycja 11.3), zawierajc nowe cechy nie opisane w ksice AWK.
Dodatkowo
.B mawk
zawiera nieco rozszerze.
.PP
Program AWK jest sekwencj par \fIwzorzec {akcja}\fP i definicji funkcji.
Krtkie programy wprowadzane s w wierszu polece, zwykle ujte w ' ', by
unikn interpretacji ich skadowych przez powok.
Dusze programy mog by czytane z pliku przy pomocy opcji \fB-f\fP.
dane wejciowe odczytywane  s z listy plikw z wiersza polece lub
ze standardowego wejcia, gdy lista ta jest pusta.
Wejcie rozbijane jest na rekordy okrelone wedug zmiennej opisujcej
separator rekordw, \fBRS\fP (record separator). Pocztkowo
\fBRS\fP="\en"
a rekordy s tosame z wierszami. Kady z rekordw porwnywany jest z kadym
ze
.IR wzorcw ,
a jeli pasuje, wykonywany jest tekst programu dla
.IR "{akcji}" .
.SH OPCJE
.TP \w'\-\fBW'u+\w'\fRsprintf=\fInum\fR'u+2n
\fB\-F \fIwarto
ustawia separator pl, \fBFS\fP, na
.IR warto .
.TP
\fB\-f \fIplik
Tekst programu jest czytany z \fIpliku\fP zamiast z wiersza polece.
Dopuszcza si wielokrotne uycie opcji
.BR \-f .
.TP
\fB\-v \fIzmn\fB=\fPwarto
przypisuje
.I warto
zmiennej programu
.IR zmn .
.TP
.B \-\|\-
wskazuje jednoznaczny koniec opcji.
.PP
Powysze opcje bd dostpne w kadej zgodnej z Posix implementacji AWK.
Opcje specyficzne dla danej implementacji poprzedzane s przez
.BR \-W .
.B mawk
udostpnia sze takich rozszerze:
.TP \w'\-\fBW'u+\w'\fRsprintf=\fInum\fR'u+2n
.B \-W version
.B mawk
wypisuje sw wersj i prawa autorskie na stdout (standardowym wyjciu), za
wkompilowane ograniczenia na stderr (standardowym wyjciu bdw).
Koczy prac z kodem 0.
.TP
.B \-W dump
wypisuje na stdout asembleropodobny listing wewntrznej
reprezentacji programu i koczy prac z kodem 0 (przy pomylnej kompilacji).
.TP
.B \-W interactive
ustawia niebuforowane zapisy na stdout i buforowane wierszami odczyty
z stdin (standardowego wejcia). Rekordy z stdin s wierszami niezalenie
od wartoci
.BR RS .
.TP
.B \-W exec \fIplik
Tekst programu czytany jest z
.I pliku
i jest to ostatnia opcja. Przydatne na systemach obsugujcych konwencj
"liczb magicznych"
.B #!
dla skryptw wykonywalnych.
.TP
.B \-W sprintf=\fInum
ustawia rozmiar bufora wewntrznego sprintf
na
.I num
bajtw. Czstsze ni sporadyczne stosowanie tej opcji wskazuje, e
.B mawk
powinien zosta zrekompilowany.
.TP
.B \-W posix_space
wymusza na
.BR mawk ,
by nie uwaa '\en' za odstp.
.PP
Rozpoznawane s krtkie postacie
.BR \-W [ vdiesp ],
za w niektrych systemach \fB\-We\fP jest obowizkowe dla uniknicia
ogranicze dugoci wiersza polece.
.SH "JZYK AWK"
.SS "1. Struktura programu"
Program w jzyku AWK jest skada si z sekwencji par
.I "wzorzec {akcja}"
i definicji funkcji uytkownika.
.PP
Wzorcem moe by:
.nf
.RS
.B BEGIN
.B END
.I wyraenie
.IB wyraenie ", " wyraenie
.sp
.RE
.fi
Mona pominc jeden z elementw z pary \fIwzorzec {akcja}\fP, ale nie oba.
Jeeli pominito
.IR {akcj} ,
to jest ni domniemane \fB{ print }\fP.
Jeeli pominito
.IR wzorzec ,
to jest on niejawnie dopasowany.
Wzorce
.B BEGIN
i
.B END
wymagaj akcji.
.PP
Instrukcje zakoczone s znakami nowej linii, rednikami
lub oboma tymi znakami.
Grupy instrukcji, jak akcje czy ciaa ptli, czone s w bloki
za porednictwem \fB{ ... }\fP, jak w C.
Ostatnia instrukcja w bloku nie wymaga znaku koczcego.
Puste wiersza nie maj znaczenia; pusta instrukcja zakoczona jest
rednikiem. Dugie instrukcje mona kontynuowa przy pomocy odwrotnego
ukonika \fB\e\fP.
Instrukcj mona podzieli midzy wiersze bez uycia odwrotnego ukonika
po przecinku, nawiasie otwierajcym, &&, ||,
.BR do ,
.BR else  ,
nawiasie zamykajcym instrukcji
.BR if ,
.B while
lub
.B for
oraz nawiasie zamykajcym definicji funkcji.
Komentarze zaczynaj si od \fB#\fP i rozcigaj si do a koca wiersza,
cho go nie obejmuj.
.PP
Ponisze instrukcje steruj przepywem programu wewntrz blokw.
.RS
.PP
.B if
( \*(ex )
.I instrukcja
.PP
.B if
( \*(ex )
.I instrukcja
.B else
.I instrukcja
.PP
.B while
( \*(ex )
.I instrukcja
.PP
.B do
.I instrukcja
.B while
( \*(ex )
.PP
.B for
(
\fIwyr_opc\fR ;
\fIwyr_opc\fR ;
\fIwyr_opc\fR
)
.I instrukcja
.PP
.B for
( \fIzmn \fBin \fItablica\fR )
.I instrukcja
.PP
.B continue
.PP
.B break
.RE
.\"
.SS "2. Typy danych, konwersja i porwnywanie"
Istniej dwa podstawowe typy danych, numeryczny i acuch znakowy.
Stae liczbowe mog by cakowite, jak \-2, dziesitne jak 1.08,
lub podane w notacji naukowej jak \-1.1e4 czy .28E\-3. Wszystkie liczby
s reprezentowane wewntrznie w arytmetyce zmiennoprzecinkowej. Wszystkie
obliczenia rwnie s zmiennoprzecinkowe.
Tak wic, na przykad, wyraenie
0.2e2 == 20
jest prawd. Prawda reprezentowana jest jako 1.0.
.PP
Stae acuchowe ujte s w cudzysowy.
.sp
.ce
"To jest acuch ze znakiem nowej linii na kocu.\en"
.sp
acuchy znakowe mog by kontynuowane w kolejnych wierszach dziki
poprzedzeniu znaku nowej linii odwrotnym ukonikiem (\e).
Rozpoznawane s nastpujce sekwencje specjalne:
.nf
.sp
    \e\e        \e
    \e"        "
    \ea        dzwonek, ascii 7
    \eb        backspace, ascii 8
    \et        tabulacja, ascii 9
    \en        znak nowej linii, newline , ascii 10
    \ev        tabulacja pionowa, ascii 11
    \ef        wysuw strony, formfeed, ascii 12
    \er        powrt karetki, carriage return, ascii 13
    \eddd      1, 2 lub 3 cyfry semkowe dla ascii ddd
    \exhh      1 lub 2 cyfry szesnastkowe dla ascii hh
.sp
.fi
Jeeli odwrotnym ukonikiem zostanie poprzedzony inny znak, np. \ec, wynikiem
bdzie sekwencja rdowa: \ec, tzn.
.B mawk
zignoruje specjalne waciwoci odwrotnego ukonika.
.PP
Naprawd istniej trzy podstawowe typy danych; trzecim jest
.IR "liczba i acuch" ,
posiadajcy rwnoczenie warto liczbow i warto acuchow.
Zmienne definiowane przez uytkownika pojawiaj si przy pierwszym
ich uyciu i s inicjowane na
.IR null ,
typu "liczba i acuch",
majce warto numeryczn 0 a acuchow "".
Nietrywialne dane typu liczbowo-acuchowego pochodz z wejcia
i zwykle przechowywane s w polach (zobacz sekcja 4).
.PP
Typ wyraenia okrelany jest przez jego kontekst. W razie potrzeby wykonywana
jest automatyczna konwersja typw. Na przykad, wyznaczenie wartoci
instrukcji
.nf
.sp
	y = x + 2  ;  z = x  "hello"
.sp
.fi
Warto przechowywana w zmiennej y otrzyma typ numeryczny.
Jeeli x nie jest numeryczne, to warto odczytana z x zostanie
skonwertowana na liczb przed dodaniem do 2 i zachowaniem w y.
Warto przechowywana w zmiennej z bdzie typu acuchowego: warto x
zostanie przeksztacona na acuch, jeli bdzie to niezbdne, i zczona
z "hello". Oczywicie, warto i typ przechowywane w x nie zmieniaj si
w adnej z tych konwersji.
Wyraenie acuchowe przeksztacane jest na numeryczne przy zastosowaniu
najduszego swego przedrostka numerycznego jak w
.IR atof (3).
Wyraenie numeryczne konwertowane jest na acuch poprzez zastpienie
.I wyra
przez
.BR sprintf(CONVFMT ,
.IR wyra ),
chyba e
.I wyra
moe by reprezentowane w danym komputerze jako dokadna liczba cakowita,
wwczas przeksztacane jest na \fBsprintf\fR("%d", \*(ex).
.B Sprintf()
jest funkcj wbudowan AWK, dublujc dziaanie
.IR sprintf (3),
za
.B CONVFMT
jest wbudowan zmienn uywan do wewntrznej konwersji z liczby na acuch
i inicjowan na "%.6g".
Mona wymusi jawn konwersj typw:
\*(ex ""
jest acuchowe, a
\*(ex+0
jest numeryczne.
.PP
Przy wyliczaniu,
\fIwyra1\fP \fBop-rel\fP \fIwyra2\fP,
jeeli oba operandy s numeryczne lub numeryczno-acuchowe, to
porwnywanie jest numeryczne; jeeli oba operandy s acuchami to
porwnywanie jest acuchowe; jeli jeden z operandw jest acuchem, to
operand nie-acuchowy jest przeksztacany i porwnywanie jest acuchowe.
Wynik jest numeryczny, 1 lub 0.
.PP
W kontekstach logicznych, jak
\fBif\fP ( \*(ex ) \fIinstrukcja\fP,
wartoci wyraenia acuchowego jest prawda wtedy i tylko wtedy, gdy
nie jest ono acuchem pustym ""; wyrae liczbowych wtedy i tylko wtedy
gdy nie s numerycznie zerem.
.\"
.SS "3. Wyraenia regularne"
W jzyku AWK rekordy, pola i acuchy s czsto sprawdzane na dopasowanie
do
.IR "wyraenia regularnego" .
Wyraenia regularne umieszczone s midzy ukonikami, a
.nf
.sp
	\*(ex ~ /\fIr\fR/
.sp
.fi
jest wyraeniem AWK o wartoci 1 jeli \*(ex "pasuje do"
.IR r ,
co oznacza, e pewien podacuch \*(ex jest w zestawie acuchw
zdefiniowanych przez
.IR r .
Jeli nie wystpuje dopasowanie, to wyraenie otrzymuje warto 0;
zastpienie \fB~\fP operatorem "nie pasuje", \fB!~\fP, odwraca znaczenia.
Pary wzorzec-akcja
.nf
.sp
        /\fIr\fR/ { \fIakcja\fR }   i\
   \fB$0\fR ~ /\fIr\fR/ { \fIakcja\fR }
.sp
.fi
s takie same,
za dla kadego rekordu wejciowego pasujcego do
.IR r
wykonywana jest
.IR akcja .
Faktycznie, /\fIr\fR/ jest wyraeniem AWK rwnowanym (\fB$0\fR ~ /\fIr\fR/)
wszdzie z wyjtkiem wystpienia po prawej stronie operatora dopasowania
lub przekazywania do funkcji wbudowanej oczekujcej jako argumentu wyraenia
regularnego.
.PP
AWK stosuje rozszerzone wyraenia regularne jak
.BR egrep (1).
Metaznakami wyrae regularnych, tj. znakami o specjalnym znaczeniu
w wyraeniach regularnych s
.nf
.sp
	\ ^ $ . [ ] | ( ) * + ?
.sp
.fi
Wyraenia regularne konstruowane s ze znakw jak niej:
.RS
.TP \w'[^c\d1\uc\d2\uc\d3\u...]'u+1n
\fIc\fR
dopasowuje dowolny znak nie bdcy metaznakiem
.IR c .
.TP
\fB\e\fIc
dopasowuje znak zdefiniowany przez t sam sekwencj specjaln uywan
w staych acuchowych lub dosowny znak
.I c
jeli
\e\fIc
nie jest sekwencj specjaln.
.TP
\fB\&\.
dopasowuje dowolny znak (cznie ze znakiem nowej linii).
.TP
\fB^
dopasowuje pocztek acucha.
.TP
\fB$
dopasowuje koniec acucha.
.TP
\fB[\fIc\d1\uc\d2\uc\d3\u\fR...\fB]
dopasowuje dowolny znak z klasy \fIc\d1\uc\d2\uc\d3\u\fP... .
Zakres znakw oznaczany jest przez \fIc\d1\u\fP\fB\-\fP\fIc\d2\u\fP
wewntrz klasy [...].
.TP
\fB[^\fIc\d1\uc\d2\uc\d3\u\fR...\fB]
dopasowuje dowolny znak nie nalecy do klasy \fIc\d1\uc\d2\uc\d3\u\fP...
.RE
.sp
Wyraenia regularne konstruowane s z innych wyrae regularnych
w nastpujcy sposb:
.RS
.TP \w'[^c\d1\uc\d2\uc\d3\u...]'u+1n
\fIr\d1\u\fIr\d2\u
dopasowuje \fIr\d1\u\fP, bezporednio po ktrym nastpuje \fIr\d2\u\fP
(konkatenacja).
.TP
\fIr\d1\u \fB| \fIr\d2\u
dopasowuje \fIr\d1\u\fP lub \fIr\d2\u\fP (alternatywa).
.TP
\fIr\fB*
dopasowuje zero lub wicej wystpie \fIr\fP .
.TP
\fIr\fB+
dopasowuje jedno lub wicej \fIr\fP.
.TP
\fIr\fB?
dopasowuje zero lub jedno \fIr\fP.
.TP
\fB(\fIr\fB)
dopasowuje \fIr\fP, umoliwiajc grupowanie.
.RE
.sp
Operatory wedug rosncego priorytetu: alternatywa, konkatenacja
(zczenie) i operatory jednoargumentowe (*, + lub ?).
.PP
Na przykad,
.nf
.sp
    /^[_a\-zA-Z][_a\-zA\-Z0\-9]*$/  i
    /^[\-+]?([0\-9]+\e\|.?|\e\|.[0\-9])[0\-9]*([eE][\-+]?[0\-9]+)?$/
.sp
.fi
dopasowuj odpowiednio identyfikatory AWK i stae liczbowe AWK.
Zauwa, e kropka \fB.\fP musi by chroniona odwrotnym ukonikiem, by zostaa
rozpoznana jako kropka dziesitna, a nie dopasowanie dowolnego znaku,
a metaznaki wewntrz klas znakw trac swe specjalne znaczenie.
.PP
Po prawej stronie operatorw ~ lub !~ moe zosta uyte dowolne wyraenie.
Podobnie, dowolne wyraenie mona przekaza do funkcji wbudowanej oczekujcej
wyraenia regularnego.
W razie potrzeby zostanie ono przeksztacone na acuch, a nastpnie
zinterpretowane jako wyraenie regularne. Na przykad,
.nf
.sp
	BEGIN { identifier = "[_a\-zA\-Z][_a\-zA\-Z0\-9]*" }

	$0 ~ "^" identifier
.sp
.fi
wypisuje wszystkie wiersze zaczynajce si od jakiego identyfikatora AWK.
.PP
.B mawk
rozpoznaje puste wyraenie regularne, //\|, dopasowujce acuch pusty.
Zatem pasuje do niego dowolny acuch na pocztku, kocu i pomidzy dowolnym
znakiem. Na przykad,
.nf
.sp
	echo  abc | mawk '{ gsub(//, "X") ; print }'
	XaXbXcX
.sp
.fi
.\"
.SS "4. Rekordy i pola"
Rekordy czytane s po jednym na raz, i przechowywane w zmiennej
.BR $0 .
Rekord rozbijany jest na
.IR pola ,
przechowywane w
.BR $1 ,
.BR $2 ", ...,"
.BR $NF .
Wbudowana zmienna
.B NF
ustawiana jest na liczb pl, a
.B NR
i
.B FNR
s zwikszane o 1.
Pola powyej
.B $NF
ustawiane s na "".
.PP
Przypisanie do
.B $0
powoduje, e pola i
.B NF
s obliczane ponownie.
Przypisanie do
.B NF
lub do pola
powoduje, e
.B $0
jest ponownie tworzone przez zczenie kolejnych pl separowanych przez
.BR OFS .
Przypisanie do pola o indeksie wikszym od
.BR NF ,
powiksza
.B NF
i powoduje ponowne utworzenie
.BR $0 .
.PP
Dane wejciowe przechowywane w polach s acuchami, chyba e cae pole
ma posta numeryczn a wwczas typ jest liczbowo-acuchowy.
Na przykad,
.sp
.nf
	echo 24 24E |
	mawk '{ print($1>100, $1>"100", $2>100, $2>"100") }'
	0 1 1 1
.fi
.sp
.B $0
i
.B $2
s acuchami a
.B $1
jest liczbowo-acuchowe. Pierwsze porwnanie jest numeryczne, drugie
acuchowe, trzecie acuchowe (100 jest konwertowane na "100"),
i ostatnie acuchowe.
.\"
.SS "5. Wyraenia i operatory"
.PP
Skadnia wyrae jest podobna jak w C. Wyraeniami pierwotnymi s stae
liczbowe, stae acuchowe, zmienne, pola, tablice i wywoania funkcji.
Identyfikator zmiennej, tablicy bd funkcji moe by cigiem liter, cyfr
i znakw podkrelenia, nie rozpoczynajcym si od cyfry.
Zmienne nie s deklarowane; zaistniej przy pierwszym do nich odwoaniu,
a inicjowane s na
.IR null .
.PP
Nowe wyraenia tworzone s z uyciem poniszych, podanych w kolejnoci
rosncego priorytetu, operatorw:
.PP
.RS
.nf
.vs +2p  \"  open up a little
\fIprzypisanie\fR                =  +=  \-=  *=  /=  %=  ^=
\fIwarunkowe\fR                 ?  :
\fIlogiczne or\fR               ||
\fIlogiczne and\fR              &&
\fIprzynaleno do tablicy\fR  \fBin
\fIdopasowanie\fR               ~   !~
\fIrelacyjne\fR                 <  >   <=  >=  ==  !=
\fIkonkatenacja\fR              (bez specjalnego operatora)
\fIdodawanie/odejmowanie\fR     +  \-
\fImnoenie/dzielenie\fR        *  /  %
\fIjednoargumentowe\fR          +  \-
\fIlogiczne not\fR              !
\fIpotgowanie\fR               ^
\fIinkrementacja/dekr.\fR       ++ \-\|\- (zarwno post jak i pre)
\fIpole\fR                      $
.vs
.RE
.PP
.fi
Przypisanie, operatory warunkowe i potgowanie wi od prawej do lewej;
pozostae  od lewej do prawej. Kade wyraenie moe by umieszczone
w nawiasach.
.\"
.SS "6. Tablice"
.ds ae \fItablica\fR[\fIwyra\fR]
Awk obsuguje tablice jednowymiarowe. Elementy tablic wskazuje si jako \*(ae.
.I Wyra
jest przeksztacane wewntrznie na typ acuchowy, wic, na przykad,
A[1] i A["1"] s tym samym elementem, a faktycznym indeksem jest "1".
Tablice indeksowane acuchami zwane s tablicami asocjacyjnymi (tablicami
przyporzdkowujcymi).
Pierwotnie tablica jest pusta; elementy zaistniej przy pierwszym do nich
odwoaniu.
Wyraenie
\fIwyra\fB in\fI tablica\fR
daje w wyniku 1 jeeli istnieje \*(ae, w przeciwnym razie 0.
.PP
Istnieje posta instrukcji
.B for
wykonujca ptl po wszystkich indeksach tablicy.
.nf
.sp
        \fBfor\fR ( \fIzmn\fB in \fItablica \fR) \fIinstrukcja\fR
.sp
.fi
ustawia
.I zmn
na kady z indeksw
.I tablicy
i wykonuje
.IR instrukcj .
Kolejno, w jakiej
.I zmn
przechodzi przez indeksy
.I tablicy
nie jest zdefiniowana.
.PP
Instrukcja
.B delete
\*(ae,
powoduje usunicie
\*(ae.
.B mawk
obsuguje rozszerzenie,
.B delete
.IR tablica ,
ktre usuwa wszystkie elementy
.IR tablicy .
.PP
Tablice wielowymiarowe tworzone s sztucznie przez konkatenacj
z zastosowaniem wbudowanej zmiennej
.BR SUBSEP .
\fItablica\fB[\fIwyra\d1\u\fB,\fIwyra\d2\u\fB]\fR
jest rwnowanikiem
\fItablica\fB[\fIwyra\d1\u \fBSUBSEP \fIwyra\d2\u\fB]\fR.
Sprawdzanie elementu tablicy wielowymiarowej uywa indeksu w nawiasach,
jak w
.sp
.nf
	if ( (i, j) in A )  print A[i, j]
.fi
.sp
.\"
.SS "7. Zmienne wbudowane"
.PP
Ponisze zmienne s zmiennymi wbudowanymi. S one inicjowane przed wykonaniem
programu.
.RS
.TP \w'FILENAME'u+2n
.B ARGC
liczba argumentw wiersza polece.
.TP
.B ARGV
tablica argumentw wiersza polece, 0..ARGC-1.
.TP
.B CONVFMT
format do wewntrznej konwersji liczb na acuchy, pocztkowo = "%.6g".
.TP
.B ENVIRON
tablica zaindeksowana zmiennymi rodowiska. acuch rodowiska,
\fIzmn=warto\fR przechowywany jest jako
.BI ENVIRON[ zmn "] ="
.IR warto .
.TP
.B FILENAME
nazwa biecego pliku wejciowego.
.TP
.B FNR
numer biecego rekordu w
.BR FILENAME .
.TP
.B FS
dzieli rekordy na pola jako wyraenie regularne.
.TP
.B NF
liczba pl biecego rekordu.
.TP
.B NR
numer biecego rekordu w cakowitym strumieniu wejciowym.
.TP
.B OFMT
format do wydruku liczb; pocztkowo = "%.6g".
.TP
.B OFS
wstawiane pomidzy polami w wyjciu, pocztkowo = " ".
.TP
.B ORS
koczy kady z rekordw wyjciowych, pocztkowo = "\en".
.TP
.B RLENGTH
dugo ustawiona przez ostatnie wywoanie wbudowanej funkcji
.BR match() .
.TP
.B RS
separator rekordw wejciowych, pocztkowo = "\en".
.TP
.B  RSTART
indeks ustawiony przez ostatnie wywoanie
.BR match() .
.TP
.B SUBSEP
uywany do budowy indeksw tablic wielowymiarowych, pocztkowo = "\e034".
.RE
.\"
.SS "8. Funkcje wbudowane"
Funkcje acuchowe
.RS
.TP
.RI \fBgsub\fP( r , s , t ")  \fBgsub\fP(" r , s )
Zastpowanie globalne (global substitution), kade dopasowanie wyraenia
regularnego
.I r
w zmiennej
.I t
zastpowane jest acuchem
.IR s .
Zwracana jest liczba wykonanych zastpie.
Jeeli pominito
.IR t ,
to uywane jest
.BR $0 .
Znak \fB&\fP w acuchu zastpujcym
.I s
zastpowany jest dopasowanym podacuchem acucha
.IR t .
\fB\e&\fP oraz \fB\e\e\fP daj, odpowiednio, dosowne \fB&\fP i \fB\e\fP
w acuchu zastpujcym.
.TP
.RI \fBindex\fP( s , t )
Jeeli
.I t
jest podacuchem
.IR s ,
to zwracana jest pozycja, na ktrej rozpoczyna si
.IR t ,
w przeciwnym razie zwracane jest 0.
Pierwszy znak
.I s
jest na pozycji 1.
.TP
.RI \fBlength\fP( s )
Zwraca dugo acucha
.IR s .
.TP
.RI \fBmatch\fP( s , r )
Zwraca indeks pierwszego najduszego dopasowania wyraenia regularnego
.I r
w acuchu
.IR s .
Zwraca 0 jeli nie wystpuje dopasowanie.
Jako skutek uboczny, nastpuje ustawienie
.B RSTART
na zwracan warto.
.B RLENGTH
ustawiane jest na dugo dopasowania lub \-1 jeli brak dopasowania.
Jeeli dopasowano acuch pusty, to
.B RLENGTH
ustawiane jest na 0, a zwracane jest 1 jeli dopasowanie byo na pocztku,
za length(\fIs\fR)+1, gdy na kocu acucha.
.TP
.RI \fBsplit\fP( s , A , r ")  \fBsplit\fP(" s , A )
acuch
.I s
rozbijany jest na pola przez wyraenie regularne
.I  r
a pola wpisywane s do tablicy
.IR A .
Zwracana jest liczba pl. Szczegy w sekcji 11 poniej.
Jeeli pominito
.IR r ,
uywane jest
.BR FS .
.TP
.RI \fBsprintf\fP( format , lista-wyra )
Zwraca acuch utworzony z
.I listy-wyrae
zgodnie z
.IR formatem .
Zobacz opis printf() poniej.
.TP
.RI \fBsub\fP( r , s , t ")  \fBsub\fP(" r , s )
Pojedyncze zastpienie. Takie samo, jak gsub(), z wyjtkiem tego, e
wykonywane jest co najwyej jedno zastpienie.
.TP
.RI \fBsubstr\fP( s , i , n ")  \fBsubstr\fP(" s , i )
Zwraca podacuch acucha
.IR s ,
poczynajc od indeksu
.IR i ,
o dugoci
.IR n .
Jeli pominito
.IR n ,
zwracana jest kocwka
.IR s ,
poczynajc od pozycji
.IR i .
.TP
.RI \fBtolower\fP( s )
Zwraca kopi
.I s
ze wszystkimi duymi literami przeksztaconymi na mae.
.TP
.RI \fBtoupper\fP( s )
Zwraca kopi
.I s
ze wszystkimi maymi literami przeksztaconymi na due.
.RE
.PP
Funkcje arytmetyczne
.RS
.PP
.nf
\fBatan2\fR(\fIy\fR,\fIx\fR)     arcus tangens z \fIy\fR/\fIx\fR pomidzy -PI i PI.
.PP
\fBcos\fR(\fIx\fR)         funkcja cosinus, \fIx\fR w radianach.
.PP
\fBexp\fR(\fIx\fR)         funkcja wykadnicza.
.PP
\fBint\fR(\fIx\fR)         zwraca \fIx\fR obcite w stron zera.
.PP
\fBlog\fR(\fIx\fR)         logarytm naturalny.
.PP
\fBrand\fR()         zwraca liczb losow midzy zero a jeden.
.PP
\fBsin\fR(\fIx\fR)         funkcja sinus, \fIx\fR w radianach.
.TP
\fBsqrt\fR(\fIx\fR)        zwraca pierwiastek kwadratowy z \fIx\fR.
.fi
.TP
.RI \fBsrand\fP( wyra ")  \fBsrand\fP()"
Inicjuje ziarenko generatora liczb losowych, uywajc zegara jeli pominito
.IR wyra ,
i zwraca warto poprzedniego ziarenka losowego.
.B mawk
inicjuje generator liczb losowych wedug zegara przy uruchomieniu,
wic nie ma faktycznej potrzeby wywoywania srand(). Srand(\fIwyra\fR)
przydaje si do powtarzania cigw pseudolosowych.
.RE
.\"
.SS "9. Wejcie i wyjcie"
Istniej dwie instrukcje wyjcia:
.B print
i
.BR printf .
.RS
.TP
.B print
zapisuje na standardowe wyjcie
.BR "$0  ORS" .
.TP
\fBprint\fP \fIwyra\d1\u\fR, \fIwyra\d2\u\fR, ..., \fIwyra\dn\u
zapisuje na standardowe wyjcie
\fIwyra\d1\u \fBOFS \fIwyra\d2\u \fBOFS\fR ... \fIwyra\dn\u
.BR ORS .
Wyraenia numeryczne s konwertowane na acuchy zgodnie z
.BR OFMT .
.TP
\fBprintf \fIformat\fR, \fIlista-wyra
powiela funkcj biblioteczn printf z C, piszc na standardowe wyjcie.
Rozpoznawany jest komplet specyfikacji formatw z ANSI C z konwersjami
%c, %d, %e, %E, %f, %g, %G, %i, %o, %s, %u, %x, %X i %%,
oraz kwalifikatorami konwersji h i l.
.RE
.PP
Lista argumentw print lub printf moe by opcjonalnie ujta w nawiasy.
Print formatuje liczby przy pomocy
.B OFMT
lub "%d" dla dokadnie cakowitych.
"%c" z argumentem numerycznym wypisuje odpowiedni znak 8-bitowy, z argumentem
acuchowym wypisuje pierwszy znak acucha.
Wyjcie print i printf mona przekierowa do pliku lub polecenia doczajc
.B >
.IR plik ,
.B >>
.I plik
lub
.B |
.I polecenie
na kocu instrukcji drukowania.
Przekierowanie otwiera
.I plik
lub
.I polecenie
tylko raz, kolejne przekierowania doczane s do ju otwartego strumienia.
Zgodnie z konwencj,
.B mawk
czy nazw pliku "/dev/stderr" z stderr, co pozwala na przekierowanie
wynikw print i printf na standardowe wyjcie diagnostyczne.
.B mawk
wie rwnie, odpowiednio, "\-" i "/dev/stdout" z stdin i stdout, co
umoliwia przysyanie tych strumieni do funkcji.
.PP
Funkcja wejcia
.B getline
ma nastpujce warianty:
.RS
.TP
.B getline
czyta do
.BR $0 ,
aktualizuje pola,
.BR NF ,
.B  NR
i
.BR FNR .
.TP
.B getline < \fIplik
czyta do
.B $0
z \fIpliku\fP, aktualizuje pola i
.BR NF .
.TP
.B getline \fIzmn
czyta nastpny rekord do zmiennej
.IR zmn ,
aktualizuje
.B NR
i
.BR FNR .
.TP
.B getline \fIzmn\fP < \fIplik
czyta nastpny rekord
.I pliku
do zmiennej
.IR zmn .
.TP
\fIpolecenie\fB | getline
przesya potokiem rekord z
.I polecenia
do
.B $0
i aktualizuje pola i
.BR NF .
.TP
\fIpolecenie\fB | getline \fIzmn
przesya potokiem rekord z
.I polecenia
do zmiennej
.IR zmn .
.RE
.PP
Getline zwraca 0 na kocu pliku, \-1 przy bdzie, w pozostaych
przypadkach 1.
.PP
Polecenia na kocu potokw wykonywane s przez /bin/sh.
.PP
Funkcja \fBclose\fR(\*(ex) zamyka plik lub potok skojarzony z
.IR wyra .
Close zwraca 0 jeeli
.I wyra
jest otwartym plikiem, kod zakoczenia jeli
.I wyra
jest poleceniem potoku, a \-1 w pozostaych przypadkach.
Close stosowane jest do ponownego odczytu pliku lub polecenia, upewnienia
si, e drugi koniec potoku wyjciowego jest zakoczony lub do zachowania
zasobw plikowych.
.\" conserve file resources.
.PP
Funkcja \fBfflush\fR(\*(ex) wymiata plik wyjciowy lub potok skojarzony z
.IR wyra .
Fflush zwraca 0 jeli
.I wyra
jest otwartym strumieniem wyjciowym, w przeciwnym razie \-1.
Fflush bez argumentu oprnia stdout.
Fflush z pustym argumentem ("") oprnia wszystkie otwarte wyjcia.
.PP
Funkcja
\fBsystem\fR(\fIwyra\fR)
wykorzystuje
/bin/sh
do wykonania
.I wyra
i zwraca kod zakoczenia polecenia
.IR wyra .
Zmiany tablicy
.B ENVIRON
nie s przekazywane poleceniom wykonywanym przez
.B system
lub potoki.
.SS "10. Funkcje definiowane przez uytkownika"
Funkcja definiowana przez uytkownika ma nastpujc skadni:
.nf
.sp
    \fBfunction\fI nazwa\fR( \fIargumenty\fR ) { \fIinstrukcje\fR }
.sp
.fi
Ciao funkcji moe zawiera instrukcj zwrcenia wartoci (return)
.nf
.sp
     \fBreturn\fI opcjonalne-wyra\fR
.sp
.fi
Instrukcja return nie jest wymagana.
Wywoania funkcji mog by zagniedane lub rekurencyjne.
Wyraenia przekazywane s funkcjom przez warto a tablice przez wskazanie.
Dodatkowe argumenty su jako zmienne lokalne i s inicjowane na
.IR null .
Na przykad,
.RI csplit( s , A )
wstawia kady znak
.I s
do tablicy
.I A
i zwraca dugo
.IR s .
.nf
.sp
	function csplit(s, A,	n, i)
	{
	  n = length(s)
	  for( i = 1 ; i <= n ; i++ ) A[i] = substr(s, i, 1)
	  return n
	}
.sp
.fi
Wstawienie dodatkowych odstpw pomidzy przekazywanymi parametrami
a zmiennymi lokalnymi wynika z konwencji.
Do funkcji mona odwoywa si przed ich zdefiniowaniem, ale nazwa funkcji
i nawias '(' rozpoczynajcy list argumentw musz si styka, by unikn
pomyki z konkatenacj.
.\"
.SS "11. Podzia acuchw, rekordw i plikw"
Programy awk uywaj tego samego algorytmu do rozbicia acuchw na tablice
przy pomocy split() i rekordw na pola wedug
.BR FS .
.B mawk
stosuje zasadniczo ten sam algorytm przy podziale plikw na rekordy
wedug
.BR RS .
.PP
.RI \fBSplit\fP( wyra , A, sep )
dziaa nastpujco:
.RS
.TP
(1)
Jeeli pominito
.IR sep ,
to jest on zastpowany przez
.BR FS .
.I Sep
moe by wyraeniem lub wyraeniem regularnym. Jeeli jest wyraeniem typu
nie-acuchowego, to jest przeksztacane na acuch.
.TP
(2)
Jeli
.I sep
= " " (pojedyncza spacja),
to <ODSTP> jest obcinana z pocztku i koca
.IR wyra ,
a
.I sep
staje si <ODSTPEM>.
.B mawk
definiuje <ODSTP> jako wyraenie regularne
/[\ \et\en]+/.
W przeciwnym wypadku
.I sep
traktowany jest jako wyraenie regularne, z wyjtkiem tego, e metaznaki
dla acucha o dugoci 1 s ignorowane, np.
split(x, A, "*") i split(x, A, /\e*/) s tym samym.
.TP
(3)
Jeeli \*(ex nie jest acuchem, jest przeksztacane na acuch.
Jeeli \*(ex jest wwczas acuchem pustym "", to split() zwraca 0
a
.I A
jest ustawiane jako puste.
W przeciwnym razie, wszystkie nienakadajce si, niepuste i najdusze
dopasowania
.I sep
w
.IR wyra ,
dziel
.I wyra
na pola, ktre wpisywane s do
.IR A .
Pola s umieszczane w
A[1], A[2], ..., A[n] a split() zwraca n, liczb pl, rwn liczbie dopasowa
plus jeden.
Dane umieszczone w
.I A
wygldajce na numeryczne otrzymuj typ liczbowo-acuchowy.
.RE
.PP
Podzia rekordw na pola dziaa tak samo, z wyjtkiem tego, i czci
wpisywane s do
.BR $1 ,
\fB$2\fR,...,
.BR $NF .
Jeeli
.B $0
jest puste,
.B NF
jest ustawiane na 0 a wszystkie
.B $i
na "".
.PP
.B mawk
dzieli pliki na rekordy przy pomocy tego samego algorytmu, ale z t niewielk
rnic, i
.B RS
jest faktycznie cigiem koczcym a nie separatorem.
(\fBORS\fR te jest faktycznie cigiem koczcym).
.RS
.PP
Np., jeeli
.B FS
= ":+" a
.B $0
= "a::b:" , to
.B NF
= 3 a
.B $1
= "a",
.B $2
= "b" i
.B $3
= "", ale
jeeli zawartoci pliku wejciowego jest "a::b:", za
.B RS
= ":+", to
istniej dwa rekordy "a" i "b".
.RE
.PP
.B RS
= " " nie ma specjalnego znaczenia.
.PP
Jeeli
.B FS
= "", to
.B mawk
rozbija rekord na pojedyncze znaki, i, podobnie
.RI split( s , A ,"")
umieszcza poszczeglne znaki
.I s
w
.IR A .
.\"
.SS "12. Rekordy wielowierszowe"
Poniewa
.B mawk
interpretuje
.B RS
jako wyraenie regularne, obsuga rekordw wielowierszowych jest atwa.
Ustawienie
.B RS
= "\en\en+", powoduje, e rekordy rozdzielane s co najmniej jednym pustym
wierszem. Jeeli
.B FS
= " " (domylnie), to pojedyncze znaki nowej linii, wedug zasad <ODSTPU>
powyej, staj si odstpami a pojedyncze znaki nowej linii s separatorami
pl.
.RS
.PP
Na przykad, jeli w pliku jest "a\ b\enc\en\en",
.B RS
= "\en\en+" a
.B FS
= "\ ", to mamy jeden rekord "a\ b\enc" z trzema polami "a", "b" i "c".
Zmiana
.B FS
= "\en", daje dwa pola "a b" i "c"; zmieniajc
.B FS
= "", otrzymujemy jedno pole identyczne jak rekord.
.RE
.PP
Traktowanie wierszy ze spacjami lub tabulacjami jako pustych mona uzyska
ustawiajc
.B RS
= "\en([\ \et]*\en)+".
W celu utrzymania zgodnoci z innymi implementacjami awk, ustawienie
.B RS
= "" daje te same wyniki, co usunicie pustych wierszy z pocztku i koca
pliku i okrelanie rekordw tak, jakby
.B RS
= "\en\en+".
Posix wymaga, by "\en" zawsze separowao rekordy gdy
.B RS
= "" niezalenie od wartoci
.BR FS .
.B mawk
nie obsuguje tej konwencji, gdy zdefiniowanie "\en" jako <ODSTPU>
czyni j zbdn.
.\"
.PP
W wikszoci przypadkw zmieniajc
.B RS
w celu obsugi rekordw wielowierszowych, stosuje si te zmienione
na "\en\en"
.BR ORS ,
aby na wyjciu zachowa odstpy midzy rekordami.
.\"
.SS "13. Wykonywanie programu"
Ta sekcja opisuje kolejno wykonywania programu.
Po pierwsze,
.B ARGC
ustawiane jest na cakowit liczb argumentw wiersza polece przekazanych
do fazy wykonania programu.
.B ARGV[0]
ustawiane jest na nazw interpretera AWK a
\fBARGV[1]\fR ...
.B ARGV[ARGC-1]
przechowuje pozostae argumenty wiersza polece z wyjtkiem opcji
i rda programu.
Na przykad, dla
.nf
.sp
	mawk  \-f  prog  v=1  A  t=hello  B
.sp
.fi
.B ARGC
= 5 oraz
.B ARGV[0]
= "mawk",
.B ARGV[1]
= "v=1",
.B ARGV[2]
= "A",
.B ARGV[3]
= "t=hello" i
.B ARGV[4]
= "B".
.PP
Nastpnie wykonywany jest kolejno kady z blokw
.BR BEGIN .
Jeeli program skada si wycznie z blokw
.BR BEGIN ,
to na tym wykonywanie si koczy, w przeciwnym razie otwierany jest strumie
wejciowy i wykonywanie jest kontynuowane.
Jeeli
.B ARGC
rwna si 1,
strumie wejciowy ustawiany jest na stdin, w przypadku przeciwnym
w poszukiwaniu argumentu plikowego sprawdzane s argumenty wiersza polece
.BR ARGV[1]  " ..."
.BR ARGV[ARGC-1] .
.PP
Argumenty wiersza polece dziel si na trzy grupy:
argumenty plikowe, argumenty przypisa i acuchy puste "".
Przypisanie ma posta
\fIzmn\fR=\fIacuch\fR.
Podczas sprawdzania
.B ARGV[i]
jako moliwego argumentu plikowego, jeli jest ono puste to jest
pomijane; jeli jest argumentem typu przypisania, odbywa si przypisanie
wartoci zmiennej
.I zmn
a
.B i
zmienia si na nastpny argument; w pozostaych przypadkach
.B ARGV[i]
jest otwierane jako wejcie.
Jeeli otwarcie nie powiedzie si, wykonywanie programu jest koczone
z kodem 2.
Jeeli aden z argumentw wiersza polece nie jest argumentem plikowym, to
wejcie pochodzi z stdin.
Getline w akcji
.B BEGIN
otwiera wejcie.  "\-" jako argument plikowy oznacza stdin.
.PP
Po otwarciu strumienia wejciowego kady z rekordw wejcia sprawdzany jest
z kadym ze
.IR wzorcw ,
a jeli pasuje, to wykonywana jest
.I akcja
skojarzona z danym wzorcem.
Wzorzec w postaci wyraenia pasuje jeli jego wartoci logiczn jest prawda
(zobacz koniec sekcji 2).
Wzorzec
.B BEGIN
zestawiany jest przed rozpoczciem odczytu wejcia,
za wzorzec
.B END
po przeczytaniu caego wejcia.
Wzorzec zakresu, \fIwyra1\fP\fB,\fP\fIwyra2\fP, dopasowuje
kady rekord pomidzy rekordem pasujcym do
.I wyra1
a rekordem pasujcym do
.I wyra2
cznie z nimi.
.PP
Po napotkaniu koca pliku w strumieniu wejciowym, sprawdzane s pozostae
argumenty wiersza polece w poszukiwaniu kolejnego argumentu plikowego.
Jeli taki istnieje, to jest otwierany, w przeciwnym wypadku przyjmuje si,
e zosta dopasowany
.I wzorzec
.B END
i wykonywane s wszystkie
.I akcje
.BR END .
.PP
W rozwaanym przykadzie, przypisanie
v=1
ma miejsce po wykonaniu
.I akcji
.BR BEGIN ,
a dana umieszczona w
v
otrzymuje typ liczbowo-acuchowy.
Nastpnie z pliku A jest czytane wejcie.
Po kocu pliku A, zmienna
t
jest ustawiana na acuch "hello", a B jest otwierany jako wejcie.
Po osigniciu koca pliku B s wykonywane
.I akcje
wzorca
.BR END .
.PP
Przebieg programu na poziomie
.I wzorzec
.I {akcja}
mona zmieni przy pomocy instrukcji
.nf
.sp
     \fBnext
     \fBexit  \fIwyra-opcjonalne\fR.
.sp
.fi
Instrukcja
.B next
powoduje, e odczyt nastpnego rekordu wejciowego i ponowne sprawdzanie
wzorcw, od pierwszej pary
.I "wzorzec {akcja}"
programu.
Polecenie
.B  exit
powoduje natychmiastowe wykonanie akcji
.B END
lub zakoczenie programu, jeli nie ma takich akcji lub jeeli
.B exit
wystpio w akcji
.BR END .
.I wyra-opcjonalne
ustawia warto kodu zakoczenia programu, chyba e zostanie ona przesonita
przez pniejszy
.B exit
lub ujawniony potem bd.
.SH PRZYKADY
.nf
1. emulacja cat.

     { print }

2. emulacja wc.

     { chars += length($0) + 1  # dodaje jeden dla \en
       words += NF
     }

     END{ print NR, words, chars }

3. zliczanie niepowtarzajcych si "faktycznych sw".

     BEGIN { FS = "[^A-Za-z]+" }

     { for(i = 1 ; i <= NF ; i++)  word[$i] = "" }

     END { delete word[""]
           for ( i in word )  cnt++
           print cnt
     }

.fi
4. sumowanie drugiego pola kadego rekordu w oparciu
o pierwsze pole.
.nf

     $1 ~ /credit\||\|gain/ { sum += $2 }
     $1 ~ /debit\||\|loss/  { sum \-= $2 }

     END { print sum }

5. sortowanie pliku, porwnywanie acuchowe

     { line[NR] = $0 "" }  # wymusza typ porwnywania: gdyby
                           # jakie wiersze wyglday
                           # na numeryczne

     END {  isort(line, NR)
       for(i = 1 ; i <= NR ; i++) print line[i]
     }

     #sortowanie A[1..n] metod wstawiania
     function isort( A, n,   i, j, hold)
     {
       for( i = 2 ; i <= n ; i++)
       {
         hold = A[j = i]
         while ( A[j\-1] > hold )
         { j\-\|\- ; A[j+1] = A[j] }
         A[j] = hold
       }
       # w razie potrzeby bdzie utworzony wartownik A[0] = ""
     }

.fi
.SH "KWESTIE ZGODNOCI"
Posix-owa 1003.2 (propozycja 11.3) definicja jzyka AWK jest AWK opisanym
w ksice AWK z kilkoma rozszerzeniami, jakie pojawiy si w nawk
z SystemVR4. Rozszerzeniami tymi s:
.sp
.RS
Nowe funkcje: toupper() i tolower().

Nowe zmienne: ENVIRON[\|] i CONVFMT.

Specyfikacje konwersji w printf() i sprintf() wzite z ANSI C.

Nowe opcje polecenia:  \-v zmn=warto, wielokrotne opcje -f i opcje
charakterystyczne dla implementacji jako argumenty \-W.
.RE
.sp

Posix-owy AWK przetwarza pojedyncze wiersze plikw.
.B RS
mona zmieni z "\en" na inny pojedynczy znak, ale trudno jest znale
jakie tego zastosowanie \(em w ksice AWK brak odpowiednich przykadw.
Zgodnie z konwencj, \fBRS\fR = "", powoduje, e jeden lub wicej pustych
wierszy rozdziela rekordy, umoliwiajc obsug rekordw wielowierszowych.
Gdy \fBRS\fR = "", "\en" jest zawsze separatorem pl, niezalenie od wartoci
.BR FS .
.PP
.BR mawk ,
z kolei,
pozwala by
.B RS
byo wyraeniem regularnym.
Pojawiajce si w rekordach "\en" jest traktowane jak odstp, a
.B FS
zawsze okrela pola.
.PP
Pozbycie si paradygmatu operowania pojedynczym wierszem moe uproci
niektre programy i czsto poprawi wydajno. Na przykad, zmienieniony
przykad 3 (zobacz powyej),
.nf
.sp
	BEGIN { RS = "[^A-Za-z]+" }

	{ word[ $0 ] = "" }

	END { delete  word[ "" ]
	  for( i in word )  cnt++
	  print cnt
	}
.sp
.fi
zlicza ilo niepowtarzajcych si sw przez
traktowanie kadego sowa jako rekordu.
Przy plikach rednich rozmiarw
.B mawk
wykonuje go dwukrotnie szybciej, dziki uproszczonej ptli wewntrznej.
.PP
Poniszy program zastpuje kady z komentarzy w pliku programu C
pojedyncz spacj,
.nf
.sp
	BEGIN {
	  RS = "/\|\e*([^*]\||\|\e*+[^/*])*\e*+/"
                # komentarz jest separatorem rekordw
	  ORS = " "
	  getline  hold
       }

       { print hold ; hold = $0 }

       END { printf "%s" , hold }
.sp
.fi
Buforowanie rekordu jest niezbdne, by unikn zakoczenia ostatniego
z rekordw spacj.
.PP
W
.B mawk
ponisze wyraenia s rwnowane,
.nf
.sp
	x ~ /a\e+b/    x ~ "a\e+b"     x ~ "a\e\e+b"
.sp
.fi
Powysze acuchy bd analizowane dwukrotnie: raz jako acuch i raz jako
wyraenie regularne. Przy analizie acucha
.B mawk
ignoruje stosowanie cytowania odwrotnym ukonikiem do znakw nie bdcych
znakami specjalnymi, zatem
.I \ec
interpretuje jako
.IR \ec .
Natomiast ksika AWK przychyla si do tego, by
.I \ec
byo rozpoznawane jako
.IR c ,
co wymaga podwojonego cytowania metaznakw w acuchach.
Posix wprost odmawia zdefiniowania podanego zachowania, przez co
porednio wymusza na programach muszcych dziaa z rnymi wersjami
awk stosowanie bardziej przenonego, lecz mniej czytelnego, cytowania
z uyciem podwjnych odwrotnych ukonikw.
.PP
Posix-owy AWK nie rozpoznaje "/dev/std{out,err}" ani sekwencji
specjalnej \ex hex w acuchach. W przeciwiestwie do ANSI C,
.B mawk
ogranicza liczb cyfr, jakie mog wystpowa po \ex do dwch, gdy obecna
implementacja obsuguje tylko znaki 8-bitowe.
Wbudowane
.B fflush
pojawio si po raz pierwszy w ostatnim (1993) awk AT&T wydanym dla netlib,
i nie jest czci standardu Posix. Caociowe usuwanie tablicy przez
.B delete
.I tablica
nie jest czci standardu Posix.
.PP
Posix jawnie zostawia niezdefiniowane zachowanie si
.B FS
= "" i wspomina o podziale rekordw na znaki jako
moliwej interpretacji, ale obecnie takie zastosowanie nie jest przenone
midzy implementacjami.
.PP
Na koniec, sposb w jaki
.B mawk
obsuguje przypadki wyjtkowe nie opisane w ksice AWK ani w propozycji
Posix. Niebezpiecznie jest zakadanie spjnoci pomidzy implementacjami
awk, a bezpiecznie przej do nastpnej sekcji.
.PP
.RS
substr(s, i, n) zwraca znaki acucha s o pozycjach z czci wsplnej
przedziau zamknitego [1, length(s)] i potwartego [i, i+n).  Gdy
cz wsplna jest pusta, zwracany jest acuch pusty; zatem
substr("ABC", 1, 0) = "" a substr("ABC", \-4, 6) = "A".
.PP
Kady acuch, nawet pusty, pasuje pocztkiem do acucha pustego, wic
s ~ // i s ~ "", s zawsze rwne 1, tak jak match(s, //) i match(s, "").
Ostanie dwa ustawiaj
.B RLENGTH
na 0.
.PP
index(s, t) jest zawsze tym samym, co match(s, t1), gdzie t1, to to samo, co
t z cytowanymi metaznakami. Std spjno z match wymaga, by index(s, "")
zawsze zwracao 1.
Rwnie warunek: index(s,t) != 0 wtedy i tylko wtedy, gdy t jest podacuchem
acucha s, wymusza by index("","") = 1.
.PP
Jeeli getline napotka koniec pliku, getline zmn pozostawia zmienn zmn
bez zmian. Podobnie, w momencie rozpoczcia akcji
.BR END ,
wartoci
.BR $0 ,
pl i
.B NF
pozostaj niezmienione od ostatniego rekordu.
.SH ZOBACZ TAKE
.BR egrep (1)
.PP
Aho, Kernighan and Weinberger,
.IR "The AWK Programming Language" ,
Addison-Wesley Publishing, 1988, (ksika AWK),
definiuje jzyk, rozpoczynajc si samouczkiem a dochodzc do wielu
interesujcych programw i wchodzc gboko w kwestie projektowania
i analizy programw istotne przy programowaniu w kadym jzyku.
.PP
.IR "The GAWK Manual" ,
The Free Software Foundation, 1991, stanowi podrcznik i opis
jzyka nie usiujcy sign gbi ksiki AWK. Zakada, e
czytelnik moe by pocztkujcym programist. Sekcja powicona tablicom
w AWK jest doskonaa. Omawia take wymagania stawiane AWK przez Posix.
.SH BDY
.B mawk
nie obsuguje znaku ascii NUL \e0 w plikach rdowych czy plikach danych.
Mona wypisa NUL przy pomocy printf z %c, a w wejciu
s dopuszczalne wszystkie inne znaki 8-bitowe.
.PP
.B mawk
implementuje printf() i sprintf() przy pomocy funkcji bibliotecznych C,
printf i sprintf, wic pena zgodno z ANSI wymaga biblioteki ANSI C.
W praktyce oznacza to, e kwalifikator konwersji h moe nie by dostpny.
.B mawk
przejmuje te wszystkie bdy czy ograniczenia tych funkcji.
.PP
Twrcy implementacji jzyka AWK ukazali zgodny brak wyobrani
w nazywaniu swych programw.
.SH AUTOR
Mike Brennan (brennan@whidbey.com).
